//*****************************************************************************
//  Copyright (c) 2021 Glenfly Tech Co., Ltd.. 
//  All Rights Reserved.
//
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Glenfly Tech Co., Ltd..;
//  the contents of this file may not be disclosed to third parties, copied or
//  duplicated in any form, in whole or in part, without the prior written
//  permission of Glenfly Tech Co., Ltd..
//
//  The copyright of the source code is protected by the copyright laws of the People's
//  Republic of China and the related laws promulgated by the People's Republic of China
//  and the international covenant(s) ratified by the People's Republic of China. 
//*****************************************************************************


#ifndef __GF_HWINFO_H__
#define __GF_HWINFO_H__

#undef  BOOL
typedef int                 BOOL;
typedef unsigned int   DWORD;
#undef  UINT64
typedef unsigned long long UINT64;



#undef  BYTE

#ifndef EXTERN_C
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#endif
#include "chip_include_e3k.h"
#include "context_gf.h"
#include "gf_bufmgr.h"
#include "mm_e3k.h"
#include "registerDef.h"
#include "registercommands.h"

#define  MMIO_Csp_Ms_Total_Gpu_Timestamp_Offset   (MMIO_CSP_START_ADDRESS + Reg_Csp_Ms_Total_Gpu_Timestamp_Offset*sizeof(DWORD))
#define  MMIO_Csp_Ref_Total_Gpu_Timestamp_Offset  (MMIO_CSP_START_ADDRESS + Reg_Csp_Ref_Total_Gpu_Timestamp_Offset_Arise1020*sizeof(DWORD)) 

#define  MMIO_Ila_Counters_Offset                (MMIO_CSP_START_ADDRESS + Reg_Ila_Counters_Offset*sizeof(DWORD))
#define  MMIO_Csp_Misc_Control_Offset            (MMIO_CSP_START_ADDRESS + Reg_Csp_Misc_Control_Offset*sizeof(DWORD))

#define S3VD_FE_CMP_COUNTER_SIZE 2
#define S3VD_BE_CMP_COUNTER_SIZE 2

#define S3VD_COUNTER_SIZE (S3VD_FE_CMP_COUNTER_SIZE + S3VD_BE_CMP_COUNTER_SIZE)

#define MS_COUNTER_SIZE   2
#define ILA_COUNTER_SZIE  40

#define CSP_COUNTER_SIZE (MS_COUNTER_SIZE + ILA_COUNTER_SZIE)

#define HWINFO_COUTER_SIZE (CSP_COUNTER_SIZE + S3VD_COUNTER_SIZE)

#define Reg_4_Offset 4
#define Reg_1_Offset 1


typedef enum
{
    RB_INDEX_GFXL = 0,       //Graphics High Ring Buffer Index;
    RB_INDEX_GFXH = 1,              //Graphics Low Ring Buffer Index;
    RB_INDEX_CSH  = 2,                //CS High Ring Buffer Index
    RB_INDEX_CSL0 = 3,               //CS  No1 RingBuffer Index
    RB_INDEX_CSL1 = 4,               //CS  No2 RingBuffer Index
    RB_INDEX_CSL2 = 5,               //CS  No3 RingBuffer Index
    RB_INDEX_CSL3 = 6,               //CS  No4 RingBuffer Index
    RB_INDEX_VCP0 = 7,
    RB_INDEX_VCP1 = 8,
    RB_INDEX_VPP  = 9,
    RB_NUM        = 10,
} RB_NODE_E3K;

typedef struct {

    unsigned int  diu_rd_db;
    unsigned int  diu_wr_db;
    unsigned int  gfx_rd_db;
    unsigned int  gfx_wr_db;
    unsigned int  vpp_rd_db;
    unsigned int  vpp_wr_db;
    unsigned int  vcp_rd_db;
    unsigned int  vcp_wr_db;
    unsigned int  local_rd_db;
    unsigned int  local_wr_db;	
    unsigned int  pcie_rd_db;	
    unsigned int  pcie_wr_db; 


} gf_meminfo;


typedef struct {

    DWORD               mode;
    DWORD               CounterSize;   // dump counter size in DWORD
    DWORD               hCounterAlloc;
    void                *virt_addr;
    DWORD               gpu_virt_addr;  // gpu phy address
    DWORD               counterval[HWINFO_COUTER_SIZE];
    unsigned long long  gputimestamp;


} counter_t;

typedef struct {

    int                 gfFd;
    context_gf_t        *renderContext;
    gf_bufmgr_t         *bufmgr;
    gf_bo_t             *bo;
    unsigned int        gfDevice;
    counter_t           counter;
    unsigned int        eclk;
    unsigned int        ChipID;
    unsigned int        RefCounter_Offset; 
 

} gf_dev_t;


typedef struct 
{
    DWORD   size;
    DWORD   offset;
    char   *name;
} HW_COUNTER_INFO;




__attribute__((visibility("default"))) EXTERN_C int  gf_get_struct_size(int fd);
__attribute__((visibility("default"))) EXTERN_C int  gf_init_hwinfo(int fd, void *pdev);
__attribute__((visibility("default"))) EXTERN_C int  gf_get_hwinfo (int fd, void *pdev, gf_meminfo *pmeminfo);
__attribute__((visibility("default"))) EXTERN_C void gf_deinit_hwinfo(int fd, void *pdev);




#endif /*__GF_HWINFO_H__*/
